#include<stdio.h>
#include <stdio.h>
#include <stdlib.h>

#include <config.h>
#include <type_sizes.h>
#include <memory_extern.h>
#include <dispatch.h>
#include <parser_extern.h>

#include "../../../N64/memory.h"
#include "../../../N64/mnemonic.h"
#include "../../../N64/registers.h"
#include "../../../N64/exceptions.h"
#include "../../../N64/interrupts.h"
#include "../../../N64/cop2.h"
#include "../../../N64/cop1.h"
#include "../../../N64/cop0.h"
#include "../../../N64/cpu.h"
#include "../../../N64/rsp_registers.h"
#include "../../../N64/rsp.h"
#include "../../../N64/memory.h"

#include <debug.h>
#include<math.h>


extern void cpu_asm_init(void);


struct rs4300i_reg reg;
void *special_instruction[64];
void *instruction[64];

int	cpustat[64];

void *regimm_instruction[32];

void *cop0_rs_instruction[32];
void *cop0_rt_instruction[32];
void *cop0_instruction[64];

void *cop1_rs_instruction[32];
void *cop1_rt_instruction[32];
void *cop1_instruction[64];

void rs4300i_special();
void rs4300i_regimm();
void rs4300i_j();
void rs4300i_jal();
void rs4300i_beq();
void rs4300i_bne();
void rs4300i_blez();
void rs4300i_bgtz();
void rs4300i_addi();
void rs4300i_addiu();
void rs4300i_slti();
void rs4300i_sltiu();
void rs4300i_andi();
void rs4300i_ori();
void rs4300i_xori();
void rs4300i_lui();
void rs4300i_cop0();
void rs4300i_cop1();
void rs4300i_cop2();
void rs4300i_beql();
void rs4300i_bnel();
void rs4300i_blezl();
void rs4300i_bgtzl();
void rs4300i_daddi();
void rs4300i_daddiu();
void rs4300i_ldl();
void rs4300i_ldr();
void rs4300i_lb();
void rs4300i_lh();
void rs4300i_lwl();
void rs4300i_lw();
void rs4300i_lbu();
void rs4300i_lhu();
void rs4300i_lwr();
void rs4300i_lwu();
void rs4300i_sb();
void rs4300i_sh();
void rs4300i_swl();
void rs4300i_sw();
void rs4300i_sdl();
void rs4300i_sdr();
void rs4300i_swr();
void rs4300i_cache();
void rs4300i_ll();
void rs4300i_lwc1();
void rs4300i_lwc2();
void rs4300i_lld();
void rs4300i_ldc1();
void rs4300i_ldc2();
void rs4300i_ld();
void rs4300i_sc();
void rs4300i_swc1();
void rs4300i_swc2();
void rs4300i_scd();
void rs4300i_sdc1();
void rs4300i_sdc2();
void rs4300i_sd();
void rs4300i_reserved();


/* 64 cpu special instructions */

void rs4300i_special_sll();
void rs4300i_special_srl();
void rs4300i_special_sra();
void rs4300i_special_sllv();
void rs4300i_special_srlv();
void rs4300i_special_srav();
void rs4300i_special_jr();
void rs4300i_special_jalr();
void rs4300i_special_syscall();
void rs4300i_special_break();
void rs4300i_special_sync();
void rs4300i_special_mfhi();
void rs4300i_special_mthi();
void rs4300i_special_mflo();
void rs4300i_special_mtlo();
void rs4300i_special_dsllv();
void rs4300i_special_dsrlv();
void rs4300i_special_dsrav();
void rs4300i_special_mult();
void rs4300i_special_multu();
void rs4300i_special_div();
void rs4300i_special_divu();
void rs4300i_special_dmult();
void rs4300i_special_dmultu();
void rs4300i_special_ddiv();
void rs4300i_special_ddivu();
void rs4300i_special_add();
void rs4300i_special_addu();
void rs4300i_special_sub();
void rs4300i_special_subu();
void rs4300i_special_and();
void rs4300i_special_or();
void rs4300i_special_xor();
void rs4300i_special_nor();
void rs4300i_special_slt();
void rs4300i_special_sltu();
void rs4300i_special_dadd();
void rs4300i_special_daddu();
void rs4300i_special_dsub();
void rs4300i_special_dsubu();
void rs4300i_special_tge();
void rs4300i_special_tgeu();
void rs4300i_special_tlt();
void rs4300i_special_tltu();
void rs4300i_special_teq();
void rs4300i_special_tne();
void rs4300i_special_dsll();
void rs4300i_special_dsrl();
void rs4300i_special_dsra();
void rs4300i_special_dsll32();
void rs4300i_special_reserved();
void rs4300i_special_dsrl32();
void rs4300i_special_dsra32();




/* 32 cpu regimm instructions */

void rs4300i_regimm_bltz();
void rs4300i_regimm_bgez();
void rs4300i_regimm_bltzl();
void rs4300i_regimm_bgezl();
void rs4300i_regimm_tgei();
void rs4300i_regimm_tgeiu();
void rs4300i_regimm_tlti();
void rs4300i_regimm_tltiu();
void rs4300i_regimm_teqi();
void rs4300i_regimm_tnei();
void rs4300i_regimm_bltzal();
void rs4300i_regimm_bgezal();
void rs4300i_regimm_bltzall();
void rs4300i_regimm_bgezall();
void rs4300i_regimm_reserved();

void rs4300i_special_sll();
void rs4300i_special_srl();
void rs4300i_special_sra();
void rs4300i_special_sllv();
void rs4300i_special_srlv();
void rs4300i_special_srav();
void rs4300i_special_jr();
void rs4300i_special_jalr();
void rs4300i_special_syscall();
void rs4300i_special_break();
void rs4300i_special_sync();
void rs4300i_special_mfhi();
void rs4300i_special_mthi();
void rs4300i_special_mflo();
void rs4300i_special_mtlo();
void rs4300i_special_dsllv();
void rs4300i_special_dsrlv();
void rs4300i_special_dsrav();
void rs4300i_special_mult();
void rs4300i_special_multu();
void rs4300i_special_div();
void rs4300i_special_divu();
void rs4300i_special_dmult();
void rs4300i_special_dmultu();
void rs4300i_special_ddiv();
void rs4300i_special_ddivu();
void rs4300i_special_add();
void rs4300i_special_addu();
void rs4300i_special_sub();
void rs4300i_special_subu();
void rs4300i_special_and();
void rs4300i_special_or();
void rs4300i_special_xor();
void rs4300i_special_nor();
void rs4300i_special_slt();
void rs4300i_special_sltu();
void rs4300i_special_dadd();
void rs4300i_special_daddu();
void rs4300i_special_dsub();
void rs4300i_special_dsubu();
void rs4300i_special_tge();
void rs4300i_special_tgeu();
void rs4300i_special_tlt();
void rs4300i_special_tltu();
void rs4300i_special_teq();
void rs4300i_special_tne();
void rs4300i_special_dsll();
void rs4300i_special_dsrl();
void rs4300i_special_dsra();
void rs4300i_special_dsll32();
void rs4300i_special_reserved();
void rs4300i_special_dsrl32();
void rs4300i_special_dsra32();




/* 32 cpu regimm instructions */

void rs4300i_regimm_bltz();
void rs4300i_regimm_bgez();
void rs4300i_regimm_bltzl();
void rs4300i_regimm_bgezl();
void rs4300i_regimm_tgei();
void rs4300i_regimm_tgeiu();
void rs4300i_regimm_tlti();
void rs4300i_regimm_tltiu();
void rs4300i_regimm_teqi();
void rs4300i_regimm_tnei();
void rs4300i_regimm_bltzal();
void rs4300i_regimm_bgezal();
void rs4300i_regimm_bltzall();
void rs4300i_regimm_bgezall();
void rs4300i_regimm_reserved();


void procdosomething(void)
{
                if(reg.do_or_check_sthg & RS4300I_DO_SI_INTERRUPT)
                        rs4300i_MI_Intr_SI();

                if(reg.do_or_check_sthg & RS4300I_DO_SP_INTERRUPT)
                        rs4300i_MI_Intr_SP();

                if(reg.do_or_check_sthg & RS4300I_DO_PI_INTERRUPT)
                        rs4300i_MI_Intr_PI();

                if(reg.do_or_check_sthg & RS4300I_CHECK_MI_INTERRUPTS)
                        rs4300i_Check_MI_Interrupts();

                if(reg.do_or_check_sthg & RS4300I_CHECK_CPU_INTERRUPTS)
                        rs4300i_Check_CPU_Interrupts();

                if(reg.do_or_check_sthg & RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION)
                        rs4300i_integer_overflow_exception();

                if(reg.do_or_check_sthg & RS4300I_DO_FLOATING_POINT_EXCEPTION)
                        rs4300i_floating_point_exception();

                if(reg.do_or_check_sthg & RS4300I_DO_TRAP_EXCEPTION)
                        rs4300i_trap_exception();

                if(reg.do_or_check_sthg & RS4300I_DO_SYSCALL_EXCEPTION)
                        rs4300i_syscall_exception();

                reg.do_or_check_sthg = RS4300I_DO_OR_CHECK_NOTHING;
}

void rs4300i_Reset()
{
        int i, j;

        /* rsp */

        rsp_reset();



        /* debugging */
#ifdef HALT
        reg.halt = 0;
#endif
        reg.do_or_check_sthg = RS4300I_DO_OR_CHECK_NOTHING;

   
   
        /* cpu registers */
   
        /* reg.pc = 0xbfc00000; */
        reg.pc = 0xa4000040;

        for(i=0; i<32; i++)
                reg.r[i] = 0;
      
        reg.r[20] = 0x0000000000000001ULL;
        reg.r[22] = 0x000000000000003fULL;
        reg.r[29] = 0x0000000000400000ULL;

        reg.hi = 0;
        reg.lo = 0;

        reg.llbit = 0;

        reg.delay = 0;



        /* cop0/1/2 registers */
   
        for(j=0; j<=2; j++)
                for(i=0; i<32; i++)
                {
                        reg.cpr[j][i] = 0;
                        reg.ccr[j][i] = 0;
                }
      
        reg.cpr[0][STATUS] = 0x70400004;
        reg.cpr[0][RANDOM] = 0x0000002f;
        reg.cpr[0][CONFIG] = 0x00066463;
        reg.cpr[0][PRID]   = 0x00000b00;
        
        reg.ccr[1][0]      = 0x00000511;


   
        /* interrupts */
   
        rs4300i_InitInterrupts();



        /* memory */
        



   
/******************************************************************************\
*                                                                              *
*   Central Processing Unit (CPU)                                              *
*                                                                              *
\******************************************************************************/
   
        /* 64 cpu instructions */

        instruction[ 0] = (void *) rs4300i_special;
        instruction[ 1] = (void *) rs4300i_regimm;
        instruction[ 2] = (void *) rs4300i_j;
        instruction[ 3] = (void *) rs4300i_jal;
        instruction[ 4] = (void *) rs4300i_beq;
        instruction[ 5] = (void *) rs4300i_bne;
        instruction[ 6] = (void *) rs4300i_blez;
        instruction[ 7] = (void *) rs4300i_bgtz;
        instruction[ 8] = (void *) rs4300i_addi;
        instruction[ 9] = (void *) rs4300i_addiu;
        instruction[10] = (void *) rs4300i_slti;
        instruction[11] = (void *) rs4300i_sltiu;
        instruction[12] = (void *) rs4300i_andi;
        instruction[13] = (void *) rs4300i_ori;
        instruction[14] = (void *) rs4300i_xori;
        instruction[15] = (void *) rs4300i_lui;
        instruction[16] = (void *) rs4300i_cop0;
        instruction[17] = (void *) rs4300i_cop1;
        instruction[18] = (void *) rs4300i_cop2;
        instruction[19] = (void *) rs4300i_reserved;
        instruction[20] = (void *) rs4300i_beql;
        instruction[21] = (void *) rs4300i_bnel;
        instruction[22] = (void *) rs4300i_blezl;
        instruction[23] = (void *) rs4300i_bgtzl;
        instruction[24] = (void *) rs4300i_daddi;
        instruction[25] = (void *) rs4300i_daddiu;
        instruction[26] = (void *) rs4300i_ldl;
        instruction[27] = (void *) rs4300i_ldr;
        instruction[28] = (void *) rs4300i_reserved;
        instruction[29] = (void *) rs4300i_reserved;
        instruction[30] = (void *) rs4300i_reserved;
        instruction[31] = (void *) rs4300i_reserved;
        instruction[32] = (void *) rs4300i_lb;
        instruction[33] = (void *) rs4300i_lh;
        instruction[34] = (void *) rs4300i_lwl;
        instruction[35] = (void *) rs4300i_lw;
        instruction[36] = (void *) rs4300i_lbu;
        instruction[37] = (void *) rs4300i_lhu;
        instruction[38] = (void *) rs4300i_lwr;
        instruction[39] = (void *) rs4300i_lwu;
        instruction[40] = (void *) rs4300i_sb;
        instruction[41] = (void *) rs4300i_sh;
        instruction[42] = (void *) rs4300i_swl;
        instruction[43] = (void *) rs4300i_sw;
        instruction[44] = (void *) rs4300i_sdl;
        instruction[45] = (void *) rs4300i_sdr;
        instruction[46] = (void *) rs4300i_swr;
        instruction[47] = (void *) rs4300i_cache;
        instruction[48] = (void *) rs4300i_ll;
        instruction[49] = (void *) rs4300i_lwc1;
        instruction[50] = (void *) rs4300i_lwc2;
        instruction[51] = (void *) rs4300i_reserved;
        instruction[52] = (void *) rs4300i_lld;
        instruction[53] = (void *) rs4300i_ldc1;
        instruction[54] = (void *) rs4300i_ldc2;
        instruction[55] = (void *) rs4300i_ld;
        instruction[56] = (void *) rs4300i_sc;
        instruction[57] = (void *) rs4300i_swc1;
        instruction[58] = (void *) rs4300i_swc2;
        instruction[59] = (void *) rs4300i_reserved;
        instruction[60] = (void *) rs4300i_scd;
        instruction[61] = (void *) rs4300i_sdc1;
        instruction[62] = (void *) rs4300i_sdc2;
        instruction[63] = (void *) rs4300i_sd;
        
        /* 64 cpu special instructions */
     
        special_instruction[ 0] = (void *) rs4300i_special_sll;    
        special_instruction[ 1] = (void *) rs4300i_special_reserved;
        special_instruction[ 2] = (void *) rs4300i_special_srl;    
        special_instruction[ 3] = (void *) rs4300i_special_sra;    
        special_instruction[ 4] = (void *) rs4300i_special_sllv;   
        special_instruction[ 5] = (void *) rs4300i_special_reserved;
        special_instruction[ 6] = (void *) rs4300i_special_srlv;   
        special_instruction[ 7] = (void *) rs4300i_special_srav;   
        special_instruction[ 8] = (void *) rs4300i_special_jr;     
        special_instruction[ 9] = (void *) rs4300i_special_jalr;   
        special_instruction[10] = (void *) rs4300i_special_reserved;
        special_instruction[11] = (void *) rs4300i_special_reserved;
        special_instruction[12] = (void *) rs4300i_special_syscall;
        special_instruction[13] = (void *) rs4300i_special_break;  
        special_instruction[14] = (void *) rs4300i_special_reserved;
        special_instruction[15] = (void *) rs4300i_special_sync;   
        special_instruction[16] = (void *) rs4300i_special_mfhi;   
        special_instruction[17] = (void *) rs4300i_special_mthi;   
        special_instruction[18] = (void *) rs4300i_special_mflo;   
        special_instruction[19] = (void *) rs4300i_special_mtlo;   
        special_instruction[20] = (void *) rs4300i_special_dsllv;  
        special_instruction[21] = (void *) rs4300i_special_reserved;
        special_instruction[22] = (void *) rs4300i_special_dsrlv;  
        special_instruction[23] = (void *) rs4300i_special_dsrav;  
        special_instruction[24] = (void *) rs4300i_special_mult;   
        special_instruction[25] = (void *) rs4300i_special_multu;  
        special_instruction[26] = (void *) rs4300i_special_div;    
        special_instruction[27] = (void *) rs4300i_special_divu;   
        special_instruction[28] = (void *) rs4300i_special_dmult;  
        special_instruction[29] = (void *) rs4300i_special_dmultu; 
        special_instruction[30] = (void *) rs4300i_special_ddiv;   
        special_instruction[31] = (void *) rs4300i_special_ddivu;  
        special_instruction[32] = (void *) rs4300i_special_add;    
        special_instruction[33] = (void *) rs4300i_special_addu;   
        special_instruction[34] = (void *) rs4300i_special_sub;    
        special_instruction[35] = (void *) rs4300i_special_subu;   
        special_instruction[36] = (void *) rs4300i_special_and;    
        special_instruction[37] = (void *) rs4300i_special_or;     
        special_instruction[38] = (void *) rs4300i_special_xor;    
        special_instruction[39] = (void *) rs4300i_special_nor;    
        special_instruction[40] = (void *) rs4300i_special_reserved;
        special_instruction[41] = (void *) rs4300i_special_reserved;
        special_instruction[42] = (void *) rs4300i_special_slt;    
        special_instruction[43] = (void *) rs4300i_special_sltu;   
        special_instruction[44] = (void *) rs4300i_special_dadd;   
        special_instruction[45] = (void *) rs4300i_special_daddu;  
        special_instruction[46] = (void *) rs4300i_special_dsub;   
        special_instruction[47] = (void *) rs4300i_special_dsubu;  
        special_instruction[48] = (void *) rs4300i_special_tge;    
        special_instruction[49] = (void *) rs4300i_special_tgeu;   
        special_instruction[50] = (void *) rs4300i_special_tlt;    
        special_instruction[51] = (void *) rs4300i_special_tltu;   
        special_instruction[52] = (void *) rs4300i_special_teq;    
        special_instruction[53] = (void *) rs4300i_special_reserved;
        special_instruction[54] = (void *) rs4300i_special_tne;    
        special_instruction[55] = (void *) rs4300i_special_reserved;
        special_instruction[56] = (void *) rs4300i_special_dsll;   
        special_instruction[57] = (void *) rs4300i_special_reserved;
        special_instruction[58] = (void *) rs4300i_special_dsrl;   
        special_instruction[59] = (void *) rs4300i_special_dsra;   
        special_instruction[60] = (void *) rs4300i_special_dsll32; 
        special_instruction[61] = (void *) rs4300i_special_reserved;
        special_instruction[62] = (void *) rs4300i_special_dsrl32;
        special_instruction[63] = (void *) rs4300i_special_dsra32;
        
        /* cpu regimm (rt) instructions */
        
        regimm_instruction[ 0] = (void *) rs4300i_regimm_bltz;   
        regimm_instruction[ 1] = (void *) rs4300i_regimm_bgez;   
        regimm_instruction[ 2] = (void *) rs4300i_regimm_bltzl;  
        regimm_instruction[ 3] = (void *) rs4300i_regimm_bgezl;  
        regimm_instruction[ 4] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[ 5] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[ 6] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[ 7] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[ 8] = (void *) rs4300i_regimm_tgei;   
        regimm_instruction[ 9] = (void *) rs4300i_regimm_tgeiu;  
        regimm_instruction[10] = (void *) rs4300i_regimm_tlti;   
        regimm_instruction[11] = (void *) rs4300i_regimm_tltiu;  
        regimm_instruction[12] = (void *) rs4300i_regimm_teqi;   
        regimm_instruction[13] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[14] = (void *) rs4300i_regimm_tnei;   
        regimm_instruction[15] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[16] = (void *) rs4300i_regimm_bltzal; 
        regimm_instruction[17] = (void *) rs4300i_regimm_bgezal; 
        regimm_instruction[18] = (void *) rs4300i_regimm_bltzall;
        regimm_instruction[19] = (void *) rs4300i_regimm_bgezall;
        regimm_instruction[20] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[21] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[22] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[23] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[24] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[25] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[26] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[27] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[28] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[29] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[30] = (void *) rs4300i_regimm_reserved;
        regimm_instruction[31] = (void *) rs4300i_regimm_reserved;
     
     
     
/******************************************************************************\
*                                                                              *
*   CoProcessor0 (COP0)                                                        *
*                                                                              *
\******************************************************************************/

        /* cop0 (rs) instructions */
     
        cop0_rs_instruction[ 0] = (void *) rs4300i_cop0_rs_mf;           
        cop0_rs_instruction[ 1] = (void *) rs4300i_cop0_rs_dmf;          
        cop0_rs_instruction[ 2] = (void *) rs4300i_cop0_rs_cf;           
        cop0_rs_instruction[ 3] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[ 4] = (void *) rs4300i_cop0_rs_mt;           
        cop0_rs_instruction[ 5] = (void *) rs4300i_cop0_rs_dmt;          
        cop0_rs_instruction[ 6] = (void *) rs4300i_cop0_rs_ct;           
        cop0_rs_instruction[ 7] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[ 8] = (void *) rs4300i_cop0_rs_bc;           
        cop0_rs_instruction[ 9] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[10] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[11] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[12] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[13] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[14] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[15] = (void *) rs4300i_cop0_rs_reserved;     
        cop0_rs_instruction[16] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[17] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[18] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[19] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[20] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[21] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[22] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[23] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[24] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[25] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[26] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[27] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[28] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[29] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[30] = (void *) rs4300i_cop0_rs_co;           
        cop0_rs_instruction[31] = (void *) rs4300i_cop0_rs_co;
     
        /* cop0 (rt) instructions */
        
        cop0_rt_instruction[ 0] = (void *) rs4300i_cop0_rt_bcf;    
        cop0_rt_instruction[ 1] = (void *) rs4300i_cop0_rt_bct;    
        cop0_rt_instruction[ 2] = (void *) rs4300i_cop0_rt_bcfl;   
        cop0_rt_instruction[ 3] = (void *) rs4300i_cop0_rt_bctl;   
        cop0_rt_instruction[ 4] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[ 5] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[ 6] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[ 7] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[ 8] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[ 9] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[10] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[11] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[12] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[13] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[14] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[15] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[16] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[17] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[18] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[19] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[20] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[21] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[22] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[23] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[24] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[25] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[26] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[27] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[28] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[29] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[30] = (void *) rs4300i_cop0_rt_reserved;
        cop0_rt_instruction[31] = (void *) rs4300i_cop0_rt_reserved;
        
        /* cop0 instructions */
        
        cop0_instruction[ 0] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[ 1] = (void *) rs4300i_cop0_tlbr;               
        cop0_instruction[ 2] = (void *) rs4300i_cop0_tlbwi;              
        cop0_instruction[ 3] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[ 4] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[ 5] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[ 6] = (void *) rs4300i_cop0_tlbwr;              
        cop0_instruction[ 7] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[ 8] = (void *) rs4300i_cop0_tlbp;               
        cop0_instruction[ 9] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[10] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[11] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[12] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[13] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[14] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[15] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[16] = (void *) rs4300i_cop0_reserved;           
        cop0_instruction[17] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[18] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[19] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[20] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[21] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[22] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[23] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[24] = (void *) rs4300i_cop0_eret;               
        cop0_instruction[25] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[26] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[27] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[28] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[29] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[30] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[31] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[32] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[33] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[34] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[35] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[36] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[37] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[38] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[39] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[40] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[41] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[42] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[43] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[44] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[45] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[46] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[47] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[48] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[49] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[50] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[51] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[52] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[53] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[54] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[55] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[56] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[57] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[58] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[59] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[60] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[61] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[62] = (void *) rs4300i_cop0_invalid;            
        cop0_instruction[63] = (void *) rs4300i_cop0_invalid;
     
     
     
/******************************************************************************\
*                                                                              *
*   CoProcessor1 - Floating Point Unit (COP1 - FPU)                            *
*                                                                              *
\******************************************************************************/

        /* cop1 (rs) instructions */
     
        cop1_rs_instruction[ 0] = (void *) rs4300i_cop1_rs_mf;           
        cop1_rs_instruction[ 1] = (void *) rs4300i_cop1_rs_dmf;          
        cop1_rs_instruction[ 2] = (void *) rs4300i_cop1_rs_cf;           
        cop1_rs_instruction[ 3] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[ 4] = (void *) rs4300i_cop1_rs_mt;           
        cop1_rs_instruction[ 5] = (void *) rs4300i_cop1_rs_dmt;          
        cop1_rs_instruction[ 6] = (void *) rs4300i_cop1_rs_ct;           
        cop1_rs_instruction[ 7] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[ 8] = (void *) rs4300i_cop1_rs_bc;           
        cop1_rs_instruction[ 9] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[10] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[11] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[12] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[13] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[14] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[15] = (void *) rs4300i_cop1_rs_reserved;     
        cop1_rs_instruction[16] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[17] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[18] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[19] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[20] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[21] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[22] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[23] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[24] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[25] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[26] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[27] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[28] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[29] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[30] = (void *) rs4300i_cop1_rs_co;           
        cop1_rs_instruction[31] = (void *) rs4300i_cop1_rs_co;
     
        /* cop1 (rt) instructions */
        
        cop1_rt_instruction[ 0] = (void *) rs4300i_cop1_rt_bcf;    
        cop1_rt_instruction[ 1] = (void *) rs4300i_cop1_rt_bct;    
        cop1_rt_instruction[ 2] = (void *) rs4300i_cop1_rt_bcfl;   
        cop1_rt_instruction[ 3] = (void *) rs4300i_cop1_rt_bctl;   
        cop1_rt_instruction[ 4] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[ 5] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[ 6] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[ 7] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[ 8] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[ 9] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[10] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[11] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[12] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[13] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[14] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[15] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[16] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[17] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[18] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[19] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[20] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[21] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[22] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[23] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[24] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[25] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[26] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[27] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[28] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[29] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[30] = (void *) rs4300i_cop1_rt_reserved;
        cop1_rt_instruction[31] = (void *) rs4300i_cop1_rt_reserved;
        
        /* cop1 (fpu) instructions */
        
        cop1_instruction[ 0] = (void *) rs4300i_cop1_add;   
        cop1_instruction[ 1] = (void *) rs4300i_cop1_sub;
        cop1_instruction[ 2] = (void *) rs4300i_cop1_mul;
        cop1_instruction[ 3] = (void *) rs4300i_cop1_div;
        cop1_instruction[ 4] = (void *) rs4300i_cop1_sqrt;
        cop1_instruction[ 5] = (void *) rs4300i_cop1_abs;
        cop1_instruction[ 6] = (void *) rs4300i_cop1_mov;
        cop1_instruction[ 7] = (void *) rs4300i_cop1_neg;
        cop1_instruction[ 8] = (void *) rs4300i_cop1_roundl;
        cop1_instruction[ 9] = (void *) rs4300i_cop1_truncl;
        cop1_instruction[10] = (void *) rs4300i_cop1_ceill;
        cop1_instruction[11] = (void *) rs4300i_cop1_floorl;
        cop1_instruction[12] = (void *) rs4300i_cop1_roundw;
        cop1_instruction[13] = (void *) rs4300i_cop1_truncw;
        cop1_instruction[14] = (void *) rs4300i_cop1_ceilw;
        cop1_instruction[15] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[16] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[17] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[18] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[19] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[20] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[21] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[22] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[23] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[24] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[25] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[26] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[27] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[28] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[29] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[30] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[31] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[32] = (void *) rs4300i_cop1_cvts;   
        cop1_instruction[33] = (void *) rs4300i_cop1_cvtd;   
        cop1_instruction[34] = (void *) rs4300i_cop1_reserved;   
        cop1_instruction[35] = (void *) rs4300i_cop1_reserved;   
        cop1_instruction[36] = (void *) rs4300i_cop1_cvtw;   
        cop1_instruction[37] = (void *) rs4300i_cop1_cvtl;   
        cop1_instruction[38] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[39] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[40] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[41] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[42] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[43] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[44] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[45] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[46] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[47] = (void *) rs4300i_cop1_reserved;
        cop1_instruction[48] = (void *) rs4300i_cop1_c;   
        cop1_instruction[49] = (void *) rs4300i_cop1_c;   
        cop1_instruction[50] = (void *) rs4300i_cop1_c;   
        cop1_instruction[51] = (void *) rs4300i_cop1_c;   
        cop1_instruction[52] = (void *) rs4300i_cop1_c;   
        cop1_instruction[53] = (void *) rs4300i_cop1_c;   
        cop1_instruction[54] = (void *) rs4300i_cop1_c;   
        cop1_instruction[55] = (void *) rs4300i_cop1_c;   
        cop1_instruction[56] = (void *) rs4300i_cop1_c;   
        cop1_instruction[57] = (void *) rs4300i_cop1_c;   
        cop1_instruction[58] = (void *) rs4300i_cop1_c;   
        cop1_instruction[59] = (void *) rs4300i_cop1_c;   
        cop1_instruction[60] = (void *) rs4300i_cop1_c;   
        cop1_instruction[61] = (void *) rs4300i_cop1_c;   
        cop1_instruction[62] = (void *) rs4300i_cop1_c;   
        cop1_instruction[63] = (void *) rs4300i_cop1_c;
        cpu_asm_init();     
        for(i=0;i<64;cpustat[i++]=0);
} /* void rs4300i_hardReset() */





/******************************************************************************\
*                                                                              *
*   Central Processing Unit (CPU)                                              *
*                                                                              *
\******************************************************************************/



void rs4300i_special()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf("special instruction:\n");
#endif
   }
#endif
   
   ((void (*)()) special_instruction[rs4300i_Funct()])();

}



void rs4300i_regimm()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf("regimm instruction:\n");
#endif
   }
#endif

   ((void (*)()) regimm_instruction[rs4300i_RT()])();

}



void rs4300i_j()
{
        DWORD count;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("j       :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" 0x%08lx", (reg.pc & 0xf0000000) + (rs4300i_Target() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   if((rs4300i_Target() << 2) == (reg.pc & 0x0ffffffc))   /* if jump to same myself  */
      if(rs4300i_NCode(4) == 0x00000000)                  /*    if next instr == nop */
      {
//         printf("count: %llx\n", reg.cpr[0][COUNT]);

         count = next_vi_interrupt;

//         if(reg.cpr[0][STATUS] & 0x00008000)   /* timer interrupt set */
            if(reg.cpr[0][COMPARE] < (count & 0xffffffff))
               if(reg.cpr[0][COMPARE] > (reg.cpr[0][COUNT] & 0xffffffff))
                  count = reg.cpr[0][COMPARE] | (reg.cpr[0][COUNT] & 0xffffffff00000000ULL);

         reg.cpr[0][COUNT] = count - 1;

//         printf("count: %llx\n\n", reg.cpr[0][COUNT]);
      }
   
   reg.delay = 1;
   reg.pc_delay = (reg.pc & 0xf0000000) + (rs4300i_Target() << 2);
   
}



void rs4300i_jal()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("jal     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" 0x%08lx", (reg.pc & 0xf0000000) + (rs4300i_Target() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.delay = 1;
   reg.pc_delay = (reg.pc & 0xf0000000)+ (rs4300i_Target() << 2);
   reg.r[31] = reg.pc + 8;

}



void rs4300i_beq()
{
        DWORD count;
        
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("beq     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%lu)", rs4300i_RS(), rs4300i_RT(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(reg.r[rs4300i_RS()] == reg.r[rs4300i_RT()])
   {
      if(rs4300i_I() == -1)                                  /* if jump to same myself  */
         if(rs4300i_NCode(4) == 0x00000000)                  /*    if next instr == nop */
         {
//            printf("count: %llx\n", reg.cpr[0][COUNT]);

            count = next_vi_interrupt;

//            if(reg.cpr[0][STATUS] & 0x00008000)   /* timer interrupt set */
               if(reg.cpr[0][COMPARE] < (count & 0xffffffff))
                  if(reg.cpr[0][COMPARE] > (reg.cpr[0][COUNT] & 0xffffffff))
                     count = reg.cpr[0][COMPARE] | (reg.cpr[0][COUNT] & 0xffffffff00000000ULL);

            reg.cpr[0][COUNT] = count - 1;

//            printf("count: %llx\n\n", reg.cpr[0][COUNT]);
         }
      
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }

}



void rs4300i_bne()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bne     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%lu)", rs4300i_RS(), rs4300i_RT(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(reg.r[rs4300i_RS()] != reg.r[rs4300i_RT()])
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
      
}



void rs4300i_blez()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("blez    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((signed)reg.r[rs4300i_RS()]) <= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
      
}



void rs4300i_bgtz()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgtz    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((signed)reg.r[rs4300i_RS()]) > 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
      
}





void rs4300i_addi()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("addi    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, 0x%04hx (%hd)", rs4300i_RT(), rs4300i_RS(), (sHWORD)rs4300i_I(), (sHWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        x = (sWORD)reg.r[rs4300i_RS()];
        y = (sWORD)rs4300i_I();
        
        z = x + y;

        
        
        if((z > 0x7fffffffLL) || (z < -0x80000000LL))
                reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
        else
                reg.r[rs4300i_RT()] = (sDWORD)(sWORD)z;

}





void rs4300i_addiu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("addiu   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%04hx (%hd)", rs4300i_RT(), rs4300i_RS(), (sHWORD)rs4300i_I(), (sHWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


    reg.r[rs4300i_RT()] = (sDWORD)(sWORD)(reg.r[rs4300i_RS()] + rs4300i_I());

}



void rs4300i_slti()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("slti    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%ld)", rs4300i_RT(), rs4300i_RS(), rs4300i_I(), rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   if(reg.r[rs4300i_RS()] < rs4300i_I())
      reg.r[rs4300i_RT()] = 1;
   else
      reg.r[rs4300i_RT()] = 0;

}



void rs4300i_sltiu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sltiu   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%lu)", rs4300i_RT(), rs4300i_RS(), rs4300i_I(), rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   if((DWORD)reg.r[rs4300i_RS()] < (DWORD)rs4300i_I())
      reg.r[rs4300i_RT()] = 1;
   else
      reg.r[rs4300i_RT()] = 0;

}



void rs4300i_andi()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("andi    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%04hx (%hu)", rs4300i_RT(), rs4300i_RS(), (HWORD)rs4300i_I(), (HWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RT()] = reg.r[rs4300i_RS()] & (HWORD)rs4300i_I();

}



void rs4300i_ori()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ori     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%04hx (%hu)", rs4300i_RT(), rs4300i_RS(), (HWORD)rs4300i_I(), (HWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RT()] = reg.r[rs4300i_RS()] | (HWORD)rs4300i_I();

}



void rs4300i_xori()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("xori    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%04hx (%hu)", rs4300i_RT(), rs4300i_RS(), (HWORD)rs4300i_I(), (HWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RT()] = reg.r[rs4300i_RS()] ^ (HWORD)rs4300i_I();

}



void rs4300i_lui()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lui     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%04hx (%hu)", rs4300i_RT(), (HWORD)rs4300i_I(), (HWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = rs4300i_I() << 16;
      
}



void rs4300i_cop0()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP0_INSTR)
   {
#ifdef DEBUG_XINST
      printf("cop0 instruction:\n");
#endif
   }
#endif

   ((void (*)()) cop0_rs_instruction[rs4300i_RS()])();
}



void rs4300i_cop1()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP1_INSTR)
   {
#ifdef DEBUG_XINST
      printf(" cop1 instruction:\n");
#endif
   }
#endif

   ((void (*)()) cop1_rs_instruction[rs4300i_RS()])();
}



void rs4300i_cop2()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP2_INSTR)
   {
#ifdef DEBUG_XINST
      printf(" cop2 instruction:\n");
#endif
   }
#endif

   ((void (*)()) cop2_rs_instruction[rs4300i_RS()])();
}



void rs4300i_beql()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("beql    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%lu)", rs4300i_RS(), rs4300i_RT(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(reg.r[rs4300i_RS()] == reg.r[rs4300i_RT()])
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}



void rs4300i_bnel()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bnel    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%08lx (%lu)", rs4300i_RS(), rs4300i_RT(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(reg.r[rs4300i_RS()] != reg.r[rs4300i_RT()])
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}



void rs4300i_blezl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("blezl   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) <= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}



void rs4300i_bgtzl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgtzl   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) > 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}





void rs4300i_daddi()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("daddi   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, 0x%05lx (%ld)", rs4300i_RT(), rs4300i_RS(), rs4300i_I(), rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        x = (sDWORD)reg.r[rs4300i_RS()];
        y = (sDWORD)rs4300i_I();
        
        z = x + y;

        
        
        if( (x>>63) ^ (y>>63) )   /* different sign ? */
                reg.r[rs4300i_RT()] = z;
        else
        {
                if( (x>>63) ^ (z>>63) )   /* different sign ? */
                        reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
                else
                        reg.r[rs4300i_RT()] = z;
        }

}





void rs4300i_daddiu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("daddiu  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%05lx (%ld)", rs4300i_RT(), rs4300i_RS(), rs4300i_I(), rs4300i_I());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RT()] = reg.r[rs4300i_RS()] + rs4300i_I();

}





void rs4300i_ldl()
{
        WORD    offset;
        DWORD   data;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ldl     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        offset = reg.r[rs4300i_RS()] + rs4300i_I();

        data = doReadMemDoubleWord(offset & 0xfffffff8);

        switch(offset % 8)
        {
            case 0:
                reg.r[rs4300i_RT()] = data;
                break;

            case 1:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x00000000000000ffLL) + (data << 8);
                break;

            case 2:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x000000000000ffffLL) + (data << 16);
                break;

            case 3:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x0000000000ffffffLL) + (data << 24);
                break;

            case 4:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x00000000ffffffffLL) + (data << 32);
                break;

            case 5:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x000000ffffffffffLL) + (data << 40);
                break;

            case 6:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x0000ffffffffffffLL) + (data << 48);
                break;

            case 7:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0x00ffffffffffffffLL) + (data << 56);
                break;

        } /* switch(offset % 8) */



        // tlb miss exception
        // tlb invalid exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_ldr()
{
        WORD    offset;
        DWORD   data;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ldr     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        offset = reg.r[rs4300i_RS()] + rs4300i_I();

        data = doReadMemDoubleWord(offset & 0xfffffff8);

        switch(offset % 8)
        {
            case 7:
                reg.r[rs4300i_RT()] = data;
                break;

            case 6:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xff00000000000000LL) + (data >> 8);
                break;

            case 5:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffff000000000000LL) + (data >> 16);
                break;

            case 4:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffff0000000000LL) + (data >> 24);
                break;

            case 3:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffffff00000000LL) + (data >> 32);
                break;

            case 2:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffffffff000000LL) + (data >> 40);
                break;

            case 1:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffffffffff0000LL) + (data >> 48);
                break;

            case 0:
                reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffffffffffff00LL) + (data >> 56);
                break;

        } /* switch(offset % 8) */



        // tlb miss exception
        // tlb invalid exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_lb()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lb      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((sBYTE)doReadMemByte(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception
      
}



void rs4300i_lh()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lh      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((sHWORD)doReadMemHalfWord(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception
      
}



void rs4300i_lwl()
{
   DWORD offset;
   WORD  data;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lwl     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   offset = (DWORD)(reg.r[rs4300i_RS()] + rs4300i_I());

   data = doReadMemWord(offset & 0xfffffffc);
   
   switch(offset % 4)
   {
      case 0:
         reg.r[rs4300i_RT()] = (sDWORD)(sWORD)data;
         break;

      case 1:
         reg.r[rs4300i_RT()]  = (sDWORD)(sWORD)((reg.r[rs4300i_RT()] & 0x000000ff) + (data << 8));
         break;

      case 2:
         reg.r[rs4300i_RT()]  = (sDWORD)(sWORD)((reg.r[rs4300i_RT()] & 0x0000ffff) + (data << 16));
         break;

      case 3:
         reg.r[rs4300i_RT()]  = (sDWORD)(sWORD)((reg.r[rs4300i_RT()] & 0x00ffffff) + (data << 24));
         break;
   }

   // exception
      
   //reg.halt = 1;
}



void rs4300i_lw()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lw      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception
      
}



void rs4300i_lbu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lbu     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((BYTE)doReadMemByte(reg.r[rs4300i_RS()] + rs4300i_I()));

}



void rs4300i_lhu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lhu     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((HWORD)doReadMemHalfWord(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception

}



void rs4300i_lwr()
{
   DWORD offset;
   WORD  data;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lwr     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   offset = (DWORD)(reg.r[rs4300i_RS()] + rs4300i_I());

   data = doReadMemWord(offset & 0xfffffffc);
   
   switch(offset % 4)
   {
      case 0:
         reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffffff00) + (data >> 24);
         break;

      case 1:
         reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xffff0000) + (data >> 16);
         break;

      case 2:
         reg.r[rs4300i_RT()]  = (reg.r[rs4300i_RT()] & 0xff000000) + (data >> 8);
         break;

      case 3:
      
         reg.r[rs4300i_RT()]  = (sDWORD)(sWORD)data;
         break;
   }

   // exception
      
   //reg.halt = 1;
}



void rs4300i_lwu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lwu     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)((WORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception
      
}



void rs4300i_sb()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sb      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemByte((BYTE)reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
      
}



void rs4300i_sh()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sh      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemHalfWord((HWORD)reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
      
}



void rs4300i_swl()
{
   DWORD offset;
   WORD  data;
   WORD  old_data;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("swl     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   offset = (DWORD)reg.r[rs4300i_RS()] + rs4300i_I();
   
   old_data = doReadMemWord(offset & 0xfffffffc);
   
   switch(offset % 4)
   {
      case 0:
         data = (WORD)reg.r[rs4300i_RT()];
         break;

      case 1:
         data = (old_data & 0xff000000) + ((WORD)reg.r[rs4300i_RT()] >> 8);
         break;

      case 2:
         data = (old_data & 0xffff0000) + ((WORD)reg.r[rs4300i_RT()] >> 16);
         break;

      case 3:
         data = (old_data & 0xffffff00) + ((WORD)reg.r[rs4300i_RT()] >> 24);
         break;

      default:
         data = 0;   /* to make compiler happy */
   }

   doWriteMemWord(data, offset & 0xfffffffc);

   // exception
   
   //reg.halt = 1;
      
}



void rs4300i_sw()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sw      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemWord((WORD)reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
      
}





void rs4300i_sdl()
{
        WORD    offset;
        DWORD   data;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sdl     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        offset = reg.r[rs4300i_RS()] + rs4300i_I();

        data = doReadMemDoubleWord(offset & 0xfffffff8);

        switch(offset % 8)
        {
            case 0:
                doWriteMemDoubleWord(reg.r[rs4300i_RT()], offset & 0xfffffff8);
                break;

            case 1:
                doWriteMemDoubleWord((data & 0xff00000000000000LL) + (reg.r[rs4300i_RT()] >> 8), offset & 0xfffffff8);
                break;

            case 2:
                doWriteMemDoubleWord((data & 0xffff000000000000LL) + (reg.r[rs4300i_RT()] >> 16), offset & 0xfffffff8);
                break;

            case 3:
                doWriteMemDoubleWord((data & 0xffffff0000000000LL) + (reg.r[rs4300i_RT()] >> 24), offset & 0xfffffff8);
                break;

            case 4:
                doWriteMemDoubleWord((data & 0xffffffff00000000LL) + (reg.r[rs4300i_RT()] >> 32), offset & 0xfffffff8);
                break;

            case 5:
                doWriteMemDoubleWord((data & 0xffffffffff000000LL) + (reg.r[rs4300i_RT()] >> 40), offset & 0xfffffff8);
                break;

            case 6:
                doWriteMemDoubleWord((data & 0xffffffffffff0000LL) + (reg.r[rs4300i_RT()] >> 48), offset & 0xfffffff8);
                break;

            case 7:
                doWriteMemDoubleWord((data & 0xffffffffffffff00LL) + (reg.r[rs4300i_RT()] >> 56), offset & 0xfffffff8);
                break;

        } /* switch(offset % 8) */



        // tlb miss exception
        // tlb invalid exception
        // tlb modification exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_sdr()
{
        WORD    offset;
        DWORD   data;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sdr     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        offset = reg.r[rs4300i_RS()] + rs4300i_I();

        data = doReadMemDoubleWord(offset & 0xfffffff8);

        switch(offset % 8)
        {
            case 7:
                doWriteMemDoubleWord(reg.r[rs4300i_RT()], offset & 0xfffffff8);
                break;

            case 6:
                doWriteMemDoubleWord((data & 0x00000000000000ffLL) + (reg.r[rs4300i_RT()] << 8), offset & 0xfffffff8);
                break;

            case 5:
                doWriteMemDoubleWord((data & 0x000000000000ffffLL) + (reg.r[rs4300i_RT()] << 16), offset & 0xfffffff8);
                break;

            case 4:
                doWriteMemDoubleWord((data & 0x0000000000ffffffLL) + (reg.r[rs4300i_RT()] << 24), offset & 0xfffffff8);
                break;

            case 3:
                doWriteMemDoubleWord((data & 0x00000000ffffffffLL) + (reg.r[rs4300i_RT()] << 32), offset & 0xfffffff8);
                break;

            case 2:
                doWriteMemDoubleWord((data & 0x000000ffffffffffLL) + (reg.r[rs4300i_RT()] << 40), offset & 0xfffffff8);
                break;

            case 1:
                doWriteMemDoubleWord((data & 0x0000ffffffffffffLL) + (reg.r[rs4300i_RT()] << 48), offset & 0xfffffff8);
                break;

            case 0:
                doWriteMemDoubleWord((data & 0x00ffffffffffffffLL) + (reg.r[rs4300i_RT()] << 56), offset & 0xfffffff8);
                break;

        } /* switch(offset % 8) */



        // tlb miss exception
        // tlb invalid exception
        // tlb modification exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_swr()
{
   DWORD offset;
   WORD  data;
   WORD  old_data;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("swr     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   offset = (DWORD)reg.r[rs4300i_RS()] + rs4300i_I();
   
   old_data = doReadMemWord(offset & 0xfffffffc);
   
   switch(offset % 4)
   {
      case 0:
         data = (old_data & 0x00ffffff) + ((WORD)reg.r[rs4300i_RT()] << 24);
         break;

      case 1:
         data = (old_data & 0x0000ffff) + ((WORD)reg.r[rs4300i_RT()] << 16);
         break;

      case 2:
         data = (old_data & 0x000000ff) + ((WORD)reg.r[rs4300i_RT()] << 8);
         break;

      case 3:
         data = (WORD)reg.r[rs4300i_RT()];
         break;

      default:
         data = 0;   /* to make compiler happy */
   }

   doWriteMemWord(data, offset & 0xfffffffc);

   // exception
      
   //reg.halt = 1;
}



void rs4300i_cache()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf("cache (NOT IMPLEMENTED - JUST IGNORED):\n");
#endif
   }
#endif
}





void rs4300i_ll()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ll      :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        reg.r[rs4300i_RT()] = (sDWORD)(sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I());

        reg.cpr[0][LLADDR] = (sDWORD)(sWORD)(reg.r[rs4300i_RS()] + rs4300i_I());

        reg.llbit = 1;



        // tlb miss exception
        // tlb invalid exception
        // bus error exception
        // address error exception

}





void rs4300i_lwc1()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("lwc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
                printf(" : (f%02u=0x%016llx)", rs4300i_RT(), (sDWORD)((sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I())));
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.cpr[1][__ft] = (sDWORD)((sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));

        // exception
      
}





void rs4300i_lwc2()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP2_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("lwc2    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" v%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
      printf(" : (v%02u=0x%016llx)", rs4300i_RT(), (sDWORD)((sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I())));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.cpr[2][rs4300i_RT()] = (sDWORD)((sWORD)doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));

   // exception
      
}





void rs4300i_lld()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("lld     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        reg.r[rs4300i_RT()] = doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I());

        reg.cpr[0][LLADDR] = (sDWORD)(sWORD)(reg.r[rs4300i_RS()] + rs4300i_I());

        reg.llbit = 1;



        // tlb miss exception
        // tlb invalid exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_ldc1()
{
        DWORD value;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ldc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        
        value = doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I());
        
        if(reg.cpr[0][STATUS] & 0x04000000)
        {
                reg.cpr[1][__ft] = value;
        }
        else
        {
                reg.cpr[1][__ft+0] = (sDWORD)(sWORD)value;
                reg.cpr[1][__ft+1] = (sDWORD)(sWORD)(value >> 32);
        }

        // exception
      
}





void rs4300i_ldc2()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP2_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ldc2    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" f%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
      printf(" : (f%02u=0x%016llx)", rs4300i_RT(), doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I()));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.cpr[2][rs4300i_RT()] = doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
}



void rs4300i_ld()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ld      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
      
}





void rs4300i_sc()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("scd     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        if(reg.llbit)
        {
                doWriteMemWord((WORD)reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());
        
        } /* if(reg.llbit) */

        reg.r[rs4300i_RT()] = (sDWORD)(sBYTE)reg.llbit;



        // tlb miss exception
        // tlb invalid exception
        // tlb modification exception
        // bus error exception
        // address error exception

}





void rs4300i_swc1()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("swc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
                printf(" : ([0x%08lx]=0x%08lx)", (WORD)reg.r[rs4300i_RS()] + rs4300i_I(), doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        doWriteMemWord(reg.cpr[1][__ft], reg.r[rs4300i_RS()] + rs4300i_I());

        // exception

}





void rs4300i_swc2()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP2_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("swc2    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" v%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
      printf(" : ([0x%08lx]=0x%08lx)", (WORD)reg.r[rs4300i_RS()] + rs4300i_I(), doReadMemWord(reg.r[rs4300i_RS()] + rs4300i_I()));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemWord(reg.cpr[2][rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception

}





void rs4300i_scd()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("scd     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        if(reg.llbit)
        {
                doWriteMemDoubleWord(reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());
        
        } /* if(reg.llbit) */

        reg.r[rs4300i_RT()] = (sDWORD)(sBYTE)reg.llbit;



        // tlb miss exception
        // tlb invalid exception
        // tlb modification exception
        // bus error exception
        // address error exception
        // reserved instruction exception (vr4300 in 32-bit user or supervisor mode)

}





void rs4300i_sdc1()
{
        DWORD value;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sdc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
                printf(" : ([0x%08lx]=0x%016llx)", (WORD)reg.r[rs4300i_RS()] + rs4300i_I(), doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I()));
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.cpr[0][STATUS] & 0x04000000)
                value = reg.cpr[1][__ft];
        else
                value = (reg.cpr[1][__ft+1] << 32) + reg.cpr[1][__ft+0];
        
        doWriteMemDoubleWord(value, reg.r[rs4300i_RS()] + rs4300i_I());

        // exception

}





void rs4300i_sdc2()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CP2_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sdc2    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" cpr[2][%02u], 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
      printf(" : ([0x%08lx]=0x%016llx)", (WORD)reg.r[rs4300i_RS()] + rs4300i_I(), doReadMemDoubleWord(reg.r[rs4300i_RS()] + rs4300i_I()));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemDoubleWord(reg.cpr[2][rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception

}



void rs4300i_sd()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sd      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%05lx(r%02u)", rs4300i_RT(), rs4300i_I(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   doWriteMemDoubleWord(reg.r[rs4300i_RT()], reg.r[rs4300i_RS()] + rs4300i_I());

   // exception
      
}



void rs4300i_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}



// 64 cpu special instructions

void rs4300i_special_sll()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sll     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)(((WORD)reg.r[rs4300i_RT()]) << rs4300i_SA());

}



void rs4300i_special_srl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("srl     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)(sWORD)((WORD)reg.r[rs4300i_RT()] >> rs4300i_SA());

}



void rs4300i_special_sra()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sra     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)((sWORD)reg.r[rs4300i_RT()] >> rs4300i_SA());

}



void rs4300i_special_sllv()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sllv    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)((sWORD)((reg.r[rs4300i_RT()]) << (reg.r[rs4300i_RS()] & 0x1f)));

}



void rs4300i_special_srlv()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("srlv    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)(sWORD)((WORD)reg.r[rs4300i_RT()] >> (reg.r[rs4300i_RS()] & 0x1f));

}



void rs4300i_special_srav()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("srav    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RD()] = (sDWORD)((sWORD)reg.r[rs4300i_RT()] >> (reg.r[rs4300i_RS()] & 0x1f));

}



void rs4300i_special_jr()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("jr      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u", rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.delay = 1;
   reg.pc_delay = reg.r[rs4300i_RS()];

}



void rs4300i_special_jalr()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("jalr    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RD(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.delay = 1;
   reg.pc_delay = reg.r[rs4300i_RS()];
   reg.r[rs4300i_RD()] = reg.pc + 8;

}



void rs4300i_special_syscall()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("syscall :");
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.do_or_check_sthg |= RS4300I_DO_SYSCALL_EXCEPTION;

}



void rs4300i_special_break()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("break   :");
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.do_or_check_sthg |= RS4300I_DO_BREAK_EXCEPTION;

}



void rs4300i_special_sync()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf("sync (NOT IMPLEMENTED - JUST DOES NOTHING):\n");
#endif
   }
#endif
}



void rs4300i_special_mfhi()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mfhi    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u", rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = reg.hi;
   
}



void rs4300i_special_mthi()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mthi    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u", rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.hi = reg.r[rs4300i_RS()];
   
}



void rs4300i_special_mflo()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mflo    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u", rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = reg.lo;
   
}



void rs4300i_special_mtlo()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mtlo    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u", rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.lo = reg.r[rs4300i_RS()];
   
}



void rs4300i_special_dsllv()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsllv   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] << (reg.r[rs4300i_RS()] & 0x1f);

}



void rs4300i_special_dsrlv()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsrlv   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = (DWORD)reg.r[rs4300i_RT()] >> (reg.r[rs4300i_RS()] & 0x1f);

}



void rs4300i_special_dsrav()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsrav   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RT(), rs4300i_RS());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] >> (reg.r[rs4300i_RS()] & 0x1f);

}





void rs4300i_special_mult()
{
   sDWORD temp;


   
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mult    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   temp = (sDWORD)((sWORD)reg.r[rs4300i_RS()]) * ((sWORD)reg.r[rs4300i_RT()]);
   reg.lo = (sDWORD)(sWORD)(temp);
   reg.hi = (sDWORD)(sWORD)(temp >> 32);

} /* void rs4300i_special_mult() */





void rs4300i_special_multu()
{
   DWORD temp;
   

   
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("multu   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   temp = (DWORD)((WORD)reg.r[rs4300i_RS()]) * ((WORD)reg.r[rs4300i_RT()]);
   reg.lo = (sDWORD)(sWORD)(temp);
   reg.hi = (sDWORD)(sWORD)(temp >> 32);

} /* void rs4300i_special_multu() */





void rs4300i_special_div()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("div     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if((sWORD)reg.r[rs4300i_RT()] != 0)
   {
      reg.lo = (sDWORD)(sWORD)((sWORD)reg.r[rs4300i_RS()] / (sWORD)reg.r[rs4300i_RT()]);
      reg.hi = (sDWORD)(sWORD)((sWORD)reg.r[rs4300i_RS()] % (sWORD)reg.r[rs4300i_RT()]);
   }

} /* void rs4300i_special_div() */





void rs4300i_special_divu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("divu    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if((WORD)reg.r[rs4300i_RT()] != 0)
   {
      reg.lo = (sDWORD)(sWORD)((WORD)reg.r[rs4300i_RS()] / (WORD)reg.r[rs4300i_RT()]);
      reg.hi = (sDWORD)(sWORD)((WORD)reg.r[rs4300i_RS()] % (WORD)reg.r[rs4300i_RT()]);
   }

} /* void rs4300i_special_divu() */





void rs4300i_special_dmult()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dmult   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   // reserved instruction exception (in 32bit mode)
   reg.lo = reg.r[rs4300i_RS()] * reg.r[rs4300i_RT()];
   reg.hi = 0;

} /* void rs4300i_special_dmult() */





void rs4300i_special_dmultu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dmultu  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   // reserved instruction exception (in 32bit mode)
   reg.lo = (DWORD)reg.r[rs4300i_RS()] * (DWORD)reg.r[rs4300i_RT()];
   reg.hi = 0;

} /* void rs4300i_special_dmultu() */





void rs4300i_special_ddiv()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ddiv    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   if(reg.r[rs4300i_RT()] != 0)
   {
      reg.lo = reg.r[rs4300i_RS()] / reg.r[rs4300i_RT()];
      reg.hi = reg.r[rs4300i_RS()] % reg.r[rs4300i_RT()];
   }

} /* void rs4300i_special_ddiv() */





void rs4300i_special_ddivu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ddivu   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   // reserved instruction exception (in 32bit mode)
   if((DWORD)reg.r[rs4300i_RT()] != 0)
   {
      reg.lo = (DWORD)reg.r[rs4300i_RS()] / (DWORD)reg.r[rs4300i_RT()];
      reg.hi = (DWORD)reg.r[rs4300i_RS()] % (DWORD)reg.r[rs4300i_RT()];
   }

} /* void rs4300i_special_ddivu() */





void rs4300i_special_add()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("add     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        x = (sWORD)reg.r[rs4300i_RS()];
        y = (sWORD)reg.r[rs4300i_RT()];
        
        z = x + y;

        
        
        if((z > 0x7fffffffLL) || (z < -0x80000000LL))
                reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
        else
                reg.r[rs4300i_RD()] = (sDWORD)(sWORD)z;

}





void rs4300i_special_addu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("addu    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = (sDWORD)(sWORD)(reg.r[rs4300i_RS()] + reg.r[rs4300i_RT()]);

}



void rs4300i_special_sub()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sub     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        x = (sWORD)reg.r[rs4300i_RS()];
        y = (sWORD)reg.r[rs4300i_RT()];
        
        z = x - y;

        
        
        if((z > 0x7fffffffLL) || (z < -0x80000000LL))
                reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
        else
                reg.r[rs4300i_RD()] = (sDWORD)(sWORD)z;

}



void rs4300i_special_subu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("subu    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = (sDWORD)((sWORD)reg.r[rs4300i_RS()] - (sWORD)reg.r[rs4300i_RT()]);

}



void rs4300i_special_and()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("and     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = reg.r[rs4300i_RS()] & reg.r[rs4300i_RT()];

}



void rs4300i_special_or()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("or      :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = reg.r[rs4300i_RS()] | reg.r[rs4300i_RT()];

}



void rs4300i_special_xor()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("xor     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = reg.r[rs4300i_RS()] ^ reg.r[rs4300i_RT()];

}



void rs4300i_special_nor()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("nor     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   reg.r[rs4300i_RD()] = ~(reg.r[rs4300i_RS()] | reg.r[rs4300i_RT()]);
}



void rs4300i_special_slt()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("slt     :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   if(reg.r[rs4300i_RS()] < reg.r[rs4300i_RT()])
      reg.r[rs4300i_RD()] = 1;
   else
      reg.r[rs4300i_RD()] = 0;

}



void rs4300i_special_sltu()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("sltu    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   if((DWORD)reg.r[rs4300i_RS()] < (DWORD)reg.r[rs4300i_RT()])
      reg.r[rs4300i_RD()] = 1;
   else
      reg.r[rs4300i_RD()] = 0;

}





void rs4300i_special_dadd()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("dadd    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        // reserved instruction exception (in 32bit mode)
        
        x = (sDWORD)reg.r[rs4300i_RS()];
        y = (sDWORD)reg.r[rs4300i_RT()];
        
        z = x + y;

        
        
        if( (x>>63) ^ (y>>63) )   /* different sign ? */
                reg.r[rs4300i_RD()] = z;
        else
        {
                if( (x>>63) ^ (z>>63) )   /* different sign ? */
                        reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
                else
                        reg.r[rs4300i_RD()] = z;
        }

}





void rs4300i_special_daddu()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("daddu   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        // reserved instruction exception (in 32bit mode)

        reg.r[rs4300i_RD()] = reg.r[rs4300i_RS()] + reg.r[rs4300i_RT()];

}



void rs4300i_special_dsub()
{
        sDWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("dsub    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        // reserved instruction exception (in 32bit mode)
        
        x = (sDWORD)reg.r[rs4300i_RS()];
        y = (sDWORD)reg.r[rs4300i_RT()];
        
        z = x - y;

        
        
        if( (x>>63) ^ (y>>63) )   /* different sign ? */
        {
                if( (x>>63) ^ (z>>63) )   /* different sign ? */
                        reg.do_or_check_sthg = RS4300I_DO_INTEGER_OVERFLOW_EXCEPTION;
                else
                        reg.r[rs4300i_RD()] = z;
        }
        else
                reg.r[rs4300i_RD()] = z;

}





void rs4300i_special_dsubu()
{
   sDWORD temp;

#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsubu   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, r%02u", rs4300i_RD(), rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif


   // reserved instruction exception (in 32bit mode)
   temp = reg.r[rs4300i_RS()] - reg.r[rs4300i_RT()];
   reg.r[rs4300i_RD()] = temp;

}





void rs4300i_special_tge()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tge     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if((sDWORD)reg.r[rs4300i_RS()] >= (sDWORD)reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_special_tgeu()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tgeu    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if((DWORD)reg.r[rs4300i_RS()] >= (DWORD)reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_special_tlt()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlt     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if((sDWORD)reg.r[rs4300i_RS()] < (sDWORD)reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_special_tltu()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tltu    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if((DWORD)reg.r[rs4300i_RS()] < (DWORD)reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
}

}





void rs4300i_special_teq()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("teq     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.r[rs4300i_RS()] == reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_special_tne()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tne     :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, r%02u", rs4300i_RS(), rs4300i_RT());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.r[rs4300i_RS()] != reg.r[rs4300i_RT()])
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_special_dsll()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsll    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] << rs4300i_SA();

}



void rs4300i_special_dsrl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsrl    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = (DWORD)reg.r[rs4300i_RT()] >> rs4300i_SA();

}



void rs4300i_special_dsra()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsra    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] >> rs4300i_SA();

}



void rs4300i_special_dsll32()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsll32  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] << (32 + rs4300i_SA());

}



void rs4300i_special_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}



void rs4300i_special_dsrl32()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsrl32  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = (DWORD)reg.r[rs4300i_RT()] >> (32 + rs4300i_SA());

}



void rs4300i_special_dsra32()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dsra32  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u, 0x%02x (%u)", rs4300i_RD(), rs4300i_RT(), rs4300i_SA(), rs4300i_SA());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   // reserved instruction exception (in 32bit mode)
   reg.r[rs4300i_RD()] = reg.r[rs4300i_RT()] >> (32 + rs4300i_SA());

}




// 32 cpu regimm instructions

void rs4300i_regimm_bltz()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bltz    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) < 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }

}

void rs4300i_regimm_bgez()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgez    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) >= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }

}

void rs4300i_regimm_bltzl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bltzl   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) < 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}

void rs4300i_regimm_bgezl()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgezl   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   if(((sDWORD)reg.r[rs4300i_RS()]) >= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}





void rs4300i_regimm_tgei()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tgei    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llxx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if((sDWORD)reg.r[rs4300i_RS()] >= (sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_tgeiu()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tgeiu   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if((DWORD)reg.r[rs4300i_RS()] >= (DWORD)(sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_tlti()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlti    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if((sDWORD)reg.r[rs4300i_RS()] < (sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_tltiu()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tltiu   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if((DWORD)reg.r[rs4300i_RS()] < (DWORD)(sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_teqi()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("teqi    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sHWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if(reg.r[rs4300i_RS()] == (sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_tnei()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tnei    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, 0x%016llx (%lld)", rs4300i_RS(), (sDWORD)(sWORD)rs4300i_I(), (sDWORD)(sWORD)rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        if(reg.r[rs4300i_RS()] != (DWORD)(sDWORD)(sWORD)rs4300i_I())
        {
                reg.do_or_check_sthg |= RS4300I_DO_TRAP_EXCEPTION;
        }

}





void rs4300i_regimm_bltzal()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bltzal  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[31] = reg.pc + 8;

   if(((sDWORD)reg.r[rs4300i_RS()]) < 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }

}

void rs4300i_regimm_bgezal()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgezal  :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[31] = reg.pc + 8;

   if(((sDWORD)reg.r[rs4300i_RS()]) >= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }

}

void rs4300i_regimm_bltzall()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bltzall :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[31] = reg.pc + 8;

   if(((sDWORD)reg.r[rs4300i_RS()]) < 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}

void rs4300i_regimm_bgezall()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("bgezall :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, 0x%08lx (%lu)", rs4300i_RS(), reg.pc + 4 + (rs4300i_I() << 2), reg.pc + 4 + (rs4300i_I() << 2));
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[31] = reg.pc + 8;

   if(((sDWORD)reg.r[rs4300i_RS()]) >= 0)
   {
      reg.delay = 1;
      reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
   }
   else
      reg.pc += 4;

}

void rs4300i_regimm_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}



/******************************************************************************\
*                                                                              *
*   CoProcessor0 (COP0)                                                        *
*                                                                              *
\******************************************************************************/

/* 32 cop0 rs instructions */

void rs4300i_cop0_rs_mf()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mfc0    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)(sWORD)reg.cpr[0][rs4300i_RD()];
   
   //cop0 unusable exception
}

void rs4300i_cop0_rs_dmf()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dmfc0   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = reg.cpr[0][rs4300i_RD()];

   //cop0 unusable exception
   //reserved instruction exception
}

void rs4300i_cop0_rs_cf()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("cfc0    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.r[rs4300i_RT()] = (sDWORD)reg.ccr[0][rs4300i_RD()];

   //cop0 unusable exception
}

void rs4300i_cop0_rs_mt()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("mtc0    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

#ifndef PUR03A_COMPATIBLE
   /* if write to COMPARE reg clr IP7 (timer interrupt) in CAUSE reg*/
   if(rs4300i_RD() == COMPARE)
   {
      reg.cpr[0][CAUSE] &= ~0x00008000;
   }
#endif
   
   /* if write to CAUSE reg mask out all bits except IP0 & IP1 */
   if(rs4300i_RD() == CAUSE)
   {
      reg.cpr[0][CAUSE] = reg.r[rs4300i_RT()] & 0x00000300;
      return;
   }
   
   reg.cpr[0][rs4300i_RD()] = reg.r[rs4300i_RT()];
   
   /*
   ** if
   **    write to STATUS reg &&
   **    write included any interrupt bits
   **
   **    check for cpu interrupts
   */

#ifndef PUR03A_COMPATIBLE
   if((rs4300i_RD() == STATUS) && (reg.r[rs4300i_RT()] & 0xff01))
      reg.do_or_check_sthg |= RS4300I_CHECK_CPU_INTERRUPTS;
#endif

   //cop0 unusable exception
}

void rs4300i_cop0_rs_dmt()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("dmtc0   :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

#ifndef PUR03A_COMPATIBLE
   /* if write to COMPARE reg clr IP7 (timer interrupt) in CAUSE reg*/
   if(rs4300i_RD() == COMPARE)
   {
      reg.cpr[0][CAUSE] &= ~0x00008000;
   }
#endif

   /* if write to CAUSE reg mask out all bits except IP0 & IP1 */
   if(rs4300i_RD() == CAUSE)
   {
      reg.cpr[0][CAUSE] = reg.r[rs4300i_RT()] & 0x00000300;
      return;
   }
   
   reg.cpr[0][rs4300i_RD()] = reg.r[rs4300i_RT()];
   
   /*
   ** if
   **    write to STATUS reg &&
   **    write included any interrupt bits
   **
   **    check for rs4300i interrupts
   */
   
#ifndef PUR03A_COMPATIBLE
   if((rs4300i_RD() == STATUS) && (reg.r[rs4300i_RT()] & 0xff01))
      reg.do_or_check_sthg |= RS4300I_CHECK_CPU_INTERRUPTS;
#endif

   //cop0 unusable exception
   //reserved instruction exception
}

void rs4300i_cop0_rs_ct()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("ctc0    :");
#endif
#ifdef DEBUG_MNEMONIC
      printf(" r%02u, r%02u", rs4300i_RT(), rs4300i_RD());
#endif
#ifdef DEBUG_INST
      printf("\n");
#endif
   }
#endif

   reg.ccr[0][rs4300i_RD()] = reg.r[rs4300i_RT()];
   
   //cop0 unusable exception
}

void rs4300i_cop0_rs_bc()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf(" cop0 bc (rt) instruction\n");
#endif
   }
#endif

   ((void (*)()) cop0_rt_instruction[rs4300i_RT()])();
  
}

void rs4300i_cop0_rs_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}

void rs4300i_cop0_rs_co()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_XINST
      printf(" cop0 co (funct) instruction:\n");
#endif
   }
#endif

   ((void (*)()) cop0_instruction[rs4300i_Funct()])();
   
}



/* 32 cop0 rt instructions */

void rs4300i_cop0_rt_bcf()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" bcf (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}

void rs4300i_cop0_rt_bct()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" bct (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}

void rs4300i_cop0_rt_bcfl()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" bcfl (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}

void rs4300i_cop0_rt_bctl()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" bctl (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}

void rs4300i_cop0_rt_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}





/* 64 cop0 function instructions */





void rs4300i_cop0_tlbr()
{
        DWORD index;



#ifdef DEBUG
        if(prefs.debug & DBG_CP0_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlbr    :\n");
#endif
        }
#endif



        index = reg.cpr[0][INDEX] & 0x1f;

        reg.cpr[0][PAGEMASK] = reg.tlb[index].hh;
        reg.cpr[0][ENTRYHI]  = reg.tlb[index].hl & ~reg.tlb[index].hh;
        reg.cpr[0][ENTRYLO1] = reg.tlb[index].lh | reg.tlb[index].g;
        reg.cpr[0][ENTRYLO0] = reg.tlb[index].ll | reg.tlb[index].g;



        // coprozessor unusable exception

} /* void rs4300i_cop0_tlbr() */





void rs4300i_cop0_tlbwi()
{
        DWORD index;



#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlbwi   :\n");
#endif
        }
#endif



        index = reg.cpr[0][INDEX];

        reg.tlb[index].hh = reg.cpr[0][PAGEMASK];
        reg.tlb[index].hl = reg.cpr[0][ENTRYHI] & ~reg.cpr[0][PAGEMASK];
        reg.tlb[index].lh = reg.cpr[0][ENTRYLO1] & 0xfffffffe;
        reg.tlb[index].ll = reg.cpr[0][ENTRYLO0] & 0xfffffffe;
        reg.tlb[index].g  = 0x01 & reg.cpr[0][ENTRYLO1] & reg.cpr[0][ENTRYLO0];



        // coprozessor unusable exception

} /* void rs4300i_cop0_tlbwi() */





void rs4300i_cop0_tlbwr()
{
        DWORD index;

#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlbwr   :\n");
#endif
        }
#endif



        index = reg.cpr[0][RANDOM];

        reg.tlb[index].hh = reg.cpr[0][PAGEMASK];
        reg.tlb[index].hl = reg.cpr[0][ENTRYHI] & ~reg.cpr[0][PAGEMASK];
        reg.tlb[index].lh = reg.cpr[0][ENTRYLO1] & 0xfffffffe;
        reg.tlb[index].ll = reg.cpr[0][ENTRYLO0] & 0xfffffffe;
        reg.tlb[index].g  = 0x01 & reg.cpr[0][ENTRYLO1] & reg.cpr[0][ENTRYLO0];



        // coprozessor unusable exception

} /* void rs4300i_cop0_tlbwr() */





void rs4300i_cop0_tlbp()
{
        int i;

#ifdef DEBUG
        if(prefs.debug & DBG_CPU_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("tlbp    :\n");
#endif
        }
#endif



        reg.cpr[0][INDEX] = 0x80000000;

        for(i=0; i<32; i++)
        {
                if
                (
                        ( (reg.tlb[i].hl & ~0x1fff) == (reg.cpr[0][ENTRYHI] & ~0x1fff) )
                        &&
                        (
                                reg.tlb[i].g
                                ||
                                ( (reg.tlb[i].hl & 0xff) == (reg.cpr[0][ENTRYHI] & 0xff) )
                        )
                )
                {
                        reg.cpr[0][INDEX] = i;
                        break;
                }
                
        } /* for(i=0; i<32; i++) */



        // coprozessor unusable exception

} /* void rs4300i_cop0_tlbp() */





void rs4300i_cop0_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}





void rs4300i_cop0_eret()
{
#ifdef DEBUG
   if(prefs.debug & DBG_CPU_INSTR)
   {
#ifdef DEBUG_OPCODE
      printf("eret    :\n");
#endif
   } /* if(prefs.debug) */
#endif

   if(reg.cpr[0][STATUS] & 0x0004)                   /* if(ERL exception)           */
   {
      reg.pc = reg.cpr[0][ERROREPC] - 4;             /*    PC = ErrorEPC            */
      reg.cpr[0][STATUS] &= 0xfffffffffffffffbULL;   /*    STATUS -= ERL            */
   }
   else                                              /* else ("normal" exception)   */
   {
      reg.pc = reg.cpr[0][EPC] - 4;                  /*    PC = EPC                 */
      reg.cpr[0][STATUS] &= 0xfffffffffffffffdULL;   /*    STATUS -= EXL            */
   }

   reg.delay = 0;
   reg.llbit = 0;
   
} /* void rs4300i_cop0_eret() */





void rs4300i_cop0_invalid()
{
#ifdef DEBUG_NOTIMPLEMENTED
      printf(" invalid (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
   reg.halt = 1;
#endif
}




/******************************************************************************\
*                                                                              *
*   CoProcessor1 - Floating Point Unit (COP1 - FPU)                            *
*                                                                              *
\******************************************************************************/

/* 32 cop1 rs instructions */

void rs4300i_cop1_rs_mf()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("mfc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, f%02u", rs4300i_RT(), __fs);
                printf(" : ([r%02u]=%016llx)", rs4300i_RT(), (sDWORD)(sWORD)fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif


        reg.r[rs4300i_RT()] = (sDWORD)(sWORD)fs;
   
        //cop1 unusable exception
}





void rs4300i_cop1_rs_dmf()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("dmfc1   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, f%02u", rs4300i_RT(), __fs);
                printf(" : ([r%02u]=%016llx)", rs4300i_RT(), fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        reg.r[rs4300i_RT()] = fs;

        //cop1 unusable exception
        //reserved instruction exception
}





void rs4300i_cop1_rs_cf()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("cfc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, ccr%02u", rs4300i_RT(), __fs);
                printf(" : ([r%02u]=%016llx)", rs4300i_RT(), (sDWORD)(sWORD)reg.ccr[1][__fs]);
                
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.r[rs4300i_RT()] = (sDWORD)(sWORD)reg.ccr[1][__fs];

        //cop1 unusable exception
}





void rs4300i_cop1_rs_mt()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("mtc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, f%02u", rs4300i_RT(), __fs);
                printf(" : ([f%02u]=%016llx)", __fs, (sDWORD)(sWORD)reg.r[rs4300i_RT()]);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.cpr[1][__fs] = (sDWORD)(sWORD)reg.r[rs4300i_RT()];
   
        //cop1 unusable exception
}





void rs4300i_cop1_rs_dmt()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("dmtc1   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, f%02u", rs4300i_RT(), __fs);
                printf(" : ([f%02u]=%016llx)", __fs, reg.r[rs4300i_RT()]);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.cpr[0][STATUS] & 0x04000000)
                reg.cpr[1][__fs] = reg.r[rs4300i_RT()];
        else
        {
                reg.cpr[1][__fs+0] = (sDWORD)(sWORD)(reg.r[rs4300i_RT()]);
                reg.cpr[1][__fs+1] = (sDWORD)(sWORD)(reg.r[rs4300i_RT()] >> 32);
        }
   
        //cop1 unusable exception
        //reserved instruction exception
}





void rs4300i_cop1_rs_ct()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ctc1    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" r%02u, ccr%02u", rs4300i_RT(), __fs);
                printf(" : ([ccr%02u]=%08lx)", __fs, (WORD)reg.r[rs4300i_RT()]);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        reg.ccr[1][__fs] = reg.r[rs4300i_RT()];
   
        //cop1 unusable exception
}





void rs4300i_cop1_rs_bc()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_XINST
                printf(" cop1 bc (rt) instruction\n");
#endif
        }
#endif

        ((void (*)()) cop1_rt_instruction[rs4300i_RT()])();
}





void rs4300i_cop1_rs_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
        printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
        reg.halt = 1;
#endif
}





void rs4300i_cop1_rs_co()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_XINST
                printf(" cop1 co (funct) instruction:\n");
#endif
        }
#endif

        ((void (*)()) cop1_instruction[rs4300i_Funct()])();
   
}





/* 32 cop1 rt (bc) instructions */



void rs4300i_cop1_rt_bcf()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("bc1f    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" %08lx", rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(!(reg.ccr[1][31] & 0x00800000))
        {
                reg.delay = 1;
                reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
        }           
 
        //cop1 unusable exception
}





void rs4300i_cop1_rt_bct()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("bc1t    :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" %08lx", rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.ccr[1][31] & 0x00800000)
        {
                reg.delay = 1;
                reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
        }           
 
        //cop1 unusable exception
}





void rs4300i_cop1_rt_bcfl()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("bc1fl   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" %08lx", rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(!(reg.ccr[1][31] & 0x00800000))
        {
                reg.delay = 1;
                reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
        }
        else
                reg.pc += 4;
 
        //cop1 unusable exception
}





void rs4300i_cop1_rt_bctl()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("bc1fl   :");
#endif
#ifdef DEBUG_MNEMONIC
                printf(" %08lx", rs4300i_I());
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif

        if(reg.ccr[1][31] & 0x00800000)
        {
                reg.delay = 1;
                reg.pc_delay = reg.pc + 4 + (rs4300i_I() << 2);
        }
        else
                reg.pc += 4;
 
        //cop1 unusable exception
}





void rs4300i_cop1_rt_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
        printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
        reg.halt = 1;
#endif
}





/* 64 cop1 rs (co - function) instructions */



extern DWORD testfunc(void);
extern void a_rs4300i_cop1_add(DWORD *,DWORD *,DWORD *,DWORD *,DWORD *);

void rs4300i_cop1_add()
{
        DWORD x, y,z;
        x = fs;
        y = ft;


        switch(__fmt)
        {
            case FMT_S:
                *((float *)&z) = *((float *)&x) + *((float *)&y);
                break;

            case FMT_D:
                *((double *)&z) = *((double *)&x) + *((double *)&y);
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g, %g\n", *((double *)&z), *((double *)&x), *((double *)&y));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
        //underflow exception
}




void rs4300i_cop1_sub()
{
        DWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sub.%c   :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u, f%02u", __fd, __fs, __ft);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;
        y = ft;


        switch(__fmt)
        {
            case FMT_S:
                *((float *)&z) = *((float *)&x) - *((float *)&y);
                break;

            case FMT_D:
                *((double *)&z) = *((double *)&x) - *((double *)&y);
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g, %g\n", *((double *)&z), *((double *)&x), *((double *)&y));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
        //underflow exception
}









void rs4300i_cop1_mul()
{
        DWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("mul.%c   :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u, f%02u", __fd, __fs, __ft);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        x = fs;
        y = ft;



        switch(__fmt)
        {
            case FMT_S:
                *((float *)&z) = *((float *)&x) * *((float *)&y);
                break;

            case FMT_D:
                *((double *)&z) = *((double *)&x) * *((double *)&y);
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g, %g\n", *((double *)&z), *((double *)&x), *((double *)&y));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
        //underflow exception
}





void rs4300i_cop1_div()
{
        DWORD x, y, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("div.%c   :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u, f%02u", __fd, __fs, __ft);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        x = fs;
        y = ft;



        switch(__fmt)
        {
            case FMT_S:
                if(*((float *)&y) != 0)
                        *((float *)&z) = *((float *)&x) / *((float *)&y);
                else
                {
                        // division-by-zero exception
                        return;
                }
                break;

            case FMT_D:
                if(*((double *)&y) != 0)
                {
                        *((double *)&z) = *((double *)&x) / *((double *)&y);
#ifdef DEBUG_MNEMONIC
                        if(prefs.debug & DBG_CP1_INSTR)
                                printf(" : %g, %g, %g\n", *((double *)&z), *((double *)&x), *((double *)&y));
#endif
                }
                else
                {
                        // division-by-zero exception
                        return;
                }
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
        //underflow exception
}





void rs4300i_cop1_sqrt()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("sqrt.%c  :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((float *)&z) = (float)sqrt((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((float *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((double *)&z) = sqrt(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((double *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception

}





void rs4300i_cop1_abs()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("abs.%c   :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((float *)&z) = (float)fabs((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((float *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((double *)&z) = fabs(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((double *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception

}





void rs4300i_cop1_mov()
{
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("mov.%c   :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        switch(__fmt)
        {
            case FMT_S:
            case FMT_D:
                store_fpr(fs);
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %016llx, %016llx\n", fd, fs);
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
}





void rs4300i_cop1_neg()
{
        DWORD z = fs;
        switch(__fmt)
        {
            case FMT_S: *((float *)&z) = -(*((float *)&z));
                break;
            case FMT_D: *((double *)&z) = -(*((double *)&z));
                break;
        } /* switch(__fmt) */
 store_fpr(z);
}





void rs4300i_cop1_roundl()
{
        DWORD   x, z;
        double  fract;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("roundl.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sDWORD *)&z) = (sDWORD)modf((double)*((float *)&x), &fract);
                if(fract >  0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) + 1;
                else if(fract < -0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) - 1;
                else if(abs(fract) == 0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) & ~1LL;
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sDWORD *)&z) = (sDWORD)modf(*((double *)&x), &fract);
                if(fract >  0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) + 1;
                else if(fract < -0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) - 1;
                else if(abs(fract) == 0.5)
                        *((sDWORD *)&z) = *((sDWORD *)&z) & ~1LL;
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}





void rs4300i_cop1_truncl()
{
        DWORD z;


        
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("truncl.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        z = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sDWORD *)&z) = (sDWORD)(*((float *)&z));
                store_fpr(z);
                break;

            case FMT_D:
                *((sDWORD *)&z) = (sDWORD)(*((double *)&z));
                store_fpr(z);
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %016llx, %g\n", *((sDWORD *)&z), (double)(*((sDWORD *)&z)));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
}





void rs4300i_cop1_ceill()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ceil.l.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sDWORD *)&z) = (sDWORD)ceil((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sDWORD *)&z) = (sDWORD)ceil(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}





void rs4300i_cop1_floorl()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("floorl.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sDWORD *)&z) = (sDWORD)floor((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sDWORD *)&z) = (sDWORD)floor(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %lld, %g\n", *((sDWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}





void rs4300i_cop1_roundw()
{
        DWORD   x, z;
        double  fract;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("roundw.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sWORD *)&z) = (sWORD)modf((double)*((float *)&x), &fract);
                if(fract >  0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) + 1;
                else if(fract < -0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) - 1;
                else if(abs(fract) == 0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) & ~1;
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sWORD *)&z) = (sWORD)modf(*((double *)&x), &fract);
                if(fract >  0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) + 1;
                else if(fract < -0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) - 1;
                else if(abs(fract) == 0.5)
                        *((sWORD *)&z) = *((sWORD *)&z) & ~1LL;
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}



extern void a_rs4300i_cop1_truncw();

void rs4300i_cop1_truncw()
{
        DWORD z;
        z = fs;
        switch(__fmt)
        {
            case FMT_S: *((sDWORD *)&z) = (sWORD)(*((float *)&z));  break;
            case FMT_D: *((sDWORD *)&z) = (sWORD)(*((double *)&z)); break;
        } 
        
      store_fpr(z);
        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception
}





void rs4300i_cop1_ceilw()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("ceil.w.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sWORD *)&z) = (sWORD)ceil((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sWORD *)&z) = (sWORD)ceil(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}





void rs4300i_cop1_floorw()
{
        DWORD x, z;



#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("floorw.%c:", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                putchar('\n');
#endif
        }
#endif



        x = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sWORD *)&z) = (sWORD)floor((double)*((float *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((float *)&x));
#endif
                break;

            case FMT_D:
                *((sWORD *)&z) = (sWORD)floor(*((double *)&x));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %ld, %g\n", *((sWORD *)&z), *((double *)&x));
#endif
                break;

            case FMT_W:
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //floating point exception
   
        //unimplemented operation exception
        //invalid operation exception
        //inexact exception
        //overflow exception

}





void rs4300i_cop1_reserved()
{
#ifdef DEBUG_NOTIMPLEMENTED
        printf(" reserved (NOT IMPLEMENTED) \n");
#endif

#ifdef HALT
        reg.halt = 1;
#endif
}





void rs4300i_cop1_cvts()
{
        DWORD z;


        
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("cvt.s.%c :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        z = fs;



        switch(__fmt)
        {
            case FMT_S:
                //exception???
                return;

            case FMT_D:
                *((float *)&z) = (float)(*((double *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((float *)&z), (double)(*((float *)&z)));
#endif
                break;

            case FMT_W:
                *((float *)&z) = (float)(*((sWORD *)&z));
                break;
                
            case FMT_L:
                *((float *)&z) = (float)(*((sDWORD *)&z));
                break;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //cop exception trap
   
        //unimplemented operation exception
        //invalid operation exception
}





void rs4300i_cop1_cvtd()
{
        DWORD z;


        
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("cvt.d.%c :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        z = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((double *)&z) = (double)(*((float *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %g, %g\n", *((double *)&z), (float)(*((double *)&z)));
#endif
                break;

            case FMT_D:
                //exception???
                return;

            case FMT_W:
                *((double *)&z) = (double)(*((sWORD *)&z));
                break;
                
            case FMT_L:
                *((double *)&z) = (double)(*((sDWORD *)&z));
                break;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //cop exception trap
   
        //unimplemented operation exception
        //invalid operation exception

        //reg.halt = 1;
}





void rs4300i_cop1_cvtw()
{
        DWORD z;


        
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("cvt.w.%c :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        z = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sWORD *)&z) = (sWORD)(*((float *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %08lx, %g\n", *((sWORD *)&z), (float)(*((sWORD *)&z)));
#endif
                break;

            case FMT_D:
                *((sWORD *)&z) = (sWORD)(*((double *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %08lx, %g\n", *((sWORD *)&z), (double)(*((sWORD *)&z)));
#endif
                break;

            case FMT_W:
                //exception???
                return;
                
            case FMT_L:
                *((sWORD *)&z) = (sWORD)(*((sDWORD *)&z));
                break;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //cop exception trap
   
        //unimplemented operation exception
        //invalid operation exception
}





void rs4300i_cop1_cvtl()
{
        DWORD z;


        
#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf("cvt.l.%c :", fmt);
#endif
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fd, __fs);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
        }
#endif



        z = fs;



        switch(__fmt)
        {
            case FMT_S:
                *((sDWORD *)&z) = (sDWORD)(*((float *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %016llx, %g\n", *((sDWORD *)&z), (float)(*((sDWORD *)&z)));
#endif
                break;

            case FMT_D:
                *((sDWORD *)&z) = (sDWORD)(*((double *)&z));
#ifdef DEBUG_MNEMONIC
                if(prefs.debug & DBG_CP1_INSTR)
                        printf(" : %016llx, %g\n", *((sDWORD *)&z), (double)(*((sDWORD *)&z)));
#endif
                break;

            case FMT_W:
                *((sDWORD *)&z) = (sDWORD)(*((sWORD *)&z));
                break;
                
            case FMT_L:
                //exception???
                return;

            default:
                //exception???
                return;
                
        } /* switch(__fmt) */



        store_fpr(z);



        //cop unusable exception
        //cop exception trap
   
        //unimplemented operation exception
        //invalid operation exception
}





void rs4300i_cop1_c()
{
        sDWORD x, y;
int a;


#ifdef DEBUG
        if(prefs.debug & DBG_CP1_INSTR)
        {
#ifdef DEBUG_OPCODE
                printf
                (
                        "c.%s.%c",
                        (rs4300i_Funct() == 0x30) ? "f" :
                                (rs4300i_Funct() == 0x31) ? "un" :
                                        (rs4300i_Funct() == 0x32) ? "eq" :
                                                (rs4300i_Funct() == 0x33) ? "ueq" :
                                                        (rs4300i_Funct() == 0x34) ? "olt" :
                                                                (rs4300i_Funct() == 0x35) ? "ult" :
                                                                        (rs4300i_Funct() == 0x36) ? "ole" :
                                                                                (rs4300i_Funct() == 0x37) ? "ule" :
                                                                                        (rs4300i_Funct() == 0x38) ? "sf" :
                                                                                                (rs4300i_Funct() == 0x39) ? "ngle" :
                                                                                                        (rs4300i_Funct() == 0x3a) ? "seq" :
                                                                                                                (rs4300i_Funct() == 0x3b) ? "ngl" :
                                                                                                                        (rs4300i_Funct() == 0x3c) ? "lt" :
                                                                                                                                (rs4300i_Funct() == 0x3d) ? "nge" :
                                                                                                                                        (rs4300i_Funct() == 0x3e) ? "le" : "ngt",
                        (rs4300i_RS() == 16) ? 's' :
                                (rs4300i_RS() == 17) ? 'd' : '?'
                );
#ifdef DEBUG_MNEMONIC
                printf(" f%02u, f%02u", __fs, __ft);
#endif
#ifdef DEBUG_INST
                printf("\n");
#endif
#endif
        }
#endif



        x = fs;
        y = ft;



        switch(__fmt)
        {
            case FMT_S:   /* c.*.s */
                switch(__function)
                {
                    case 0x30:   /* c.f */
                        reg.ccr[1][31] &= ~0x00800000;
                        break;
                        
                    case 0x31:   /* c.un */
                        reg.halt = 1;
                        break;
                        
                    case 0x32:   /* c.eq */
                        if( *((float *)&x) == *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x33:   /* c.ueq */
                        /* BUG: check NaN */
                        if( *((float *)&x) == *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x34:   /* c.olt */
                        reg.halt = 1;
                        break;
                    
                    case 0x35:   /* c.ult */
                        reg.halt = 1;
                        break;
                    
                    case 0x36:   /* c.ole */
                        reg.halt = 1;
                        break;
                    
                    case 0x37:   /* c.ule */
                        reg.halt = 1;
                        break;
                    
                    case 0x38:   /* c.sf */
                        reg.halt = 1;
                        break;
                    
                    case 0x39:   /* c.ngle */
                        reg.halt = 1;
                        break;
                    
                    case 0x3a:   /* c.seq */
                        reg.halt = 1;
                        break;
                    
                    case 0x3b:   /* c.ngl */
                        reg.halt = 1;
                        break;
                    
                    case 0x3c:   /* c.lt */
                        if( *((float *)&x) < *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3d:   /* c.nge */
                        /* BUG: check NaN */
                        if( *((float *)&x) < *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3e:   /* c.le */
                        if( *((float *)&x) <= *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3f:   /* c.ngt */
                        /* BUG: check NaN */
                        if( *((float *)&x) <= *((float *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;

                } /* switch(__function) */
                
                break;
            
            case FMT_D:   /* c.*.d */
                switch(__function)
                {
                    case 0x30:   /* c.f */
                        reg.ccr[1][31] &= ~0x00800000;
                        break;
                        
                    case 0x31:   /* c.un */
                        reg.halt = 1;
                        break;
                        
                    case 0x32:   /* c.eq */
                        if( *((double *)&x) == *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x33:   /* c.ueq */
                        /* BUG: check NaN */
                        if( *((double *)&x) == *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x34:   /* c.olt */
                        reg.halt = 1;
                        break;
                    
                    case 0x35:   /* c.ult */
                        reg.halt = 1;
                        break;
                    
                    case 0x36:   /* c.ole */
                        reg.halt = 1;
                        break;
                    
                    case 0x37:   /* c.ule */
                        reg.halt = 1;
                        break;
                    
                    case 0x38:   /* c.sf */
                        reg.halt = 1;
                        break;
                    
                    case 0x39:   /* c.ngle */
                        reg.halt = 1;
                        break;
                    
                    case 0x3a:   /* c.seq */
                        reg.halt = 1;
                        break;
                    
                    case 0x3b:   /* c.ngl */
                        reg.halt = 1;
                        break;
                    
                    case 0x3c:   /* c.lt */
                        if( *((double *)&x) < *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3d:   /* c.nge */
                        /* BUG: check NaN */
                        if( *((double *)&x) < *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3e:   /* c.le */
                        if( *((double *)&x) <= *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;
                    
                    case 0x3f:   /* c.ngt */
                        /* BUG: check NaN */
                        if( *((double *)&x) <= *((double *)&y) )
                                reg.ccr[1][31] |= 0x00800000;
                        else
                                reg.ccr[1][31] &= ~0x00800000;
                        break;

                } /* switch(__function) */
                
                break;

            default:
                // exception
                reg.halt = 1;
                
        } /* switch(__fmt) */
        a=reg.ccr[1][31];
//        a_rs4300i_cop1_c();
//        if (reg.ccr[1][31] != a)
//        {
//         printf("not equal\n");
//         printf("function=%d\n",__function);
//         reg.halt=1;
 //       } 
} /* void rs4300i_cop1_c() */





