/**
 * TrueReality - include/type_sizes.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#define __TYPE_SIZES_H



/*
 *   unsigned types
 *
 */

#define DOUBLEWORD unsigned long long   /* 64 bit */
#define SEPTIBYTE  unsigned long long   /* 56 bit */
#define SEXTIBYTE  unsigned long long   /* 48 bit */
#define QUINTIBYTE unsigned long long   /* 40 bit */
#define WORD       unsigned long        /* 32 bit */
#define TRIPLEBYTE unsigned long        /* 24 bit */
#define HALFWORD   unsigned short       /* 16 bit */
#define BYTE       unsigned char        /*  8 bit */
#define BIT        unsigned char        /*  1 bit */

/* these are (very) often used */
#define DWORD      unsigned long long   /* 64 bit */
#define HWORD      unsigned short       /* 16 bit */



/*
 *   signed types
 *
 */

#define sDOUBLEWORD signed long long    /* 64 bit */
#define sSEPTIBYTE  signed long long    /* 56 bit */
#define sSEXTIBYTE  signed long long    /* 48 bit */
#define sQUINTIBYTE signed long long    /* 40 bit */
#define sWORD       signed long         /* 32 bit */
#define sTRIPLEBYTE signed long         /* 24 bit */
#define sHALFWORD   signed short        /* 16 bit */
#define sBYTE       signed char         /*  8 bit */

/* these are (very) often used */
#define sDWORD      signed long long    /* 64 bit */
#define sHWORD      signed short        /* 16 bit */



