/**
 * TrueReality - output/display/display.h
 * Copyright (C) 1998, 1999 Niki W. Waibel
 *
 * This program is free software; you can redistribute it and/
 * or modify it under the terms of the GNU General Public Li-
 * cence as published by the Free Software Foundation; either
 * version 2 of the Licence, or any later version.
 *
 * This program is distributed in the hope that it will be use-
 * ful, but WITHOUT ANY WARRANTY; without even the implied war-
 * ranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public Licence for more details.
 *
 * You should have received a copy of the GNU General Public
 * Licence along with this program; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
 * USA.
 *
 * Information about me (the author):
 *   Niki W. Waibel, Reichenau 20, 6890 Lustenau, Austria - EUROPE
 *   niki.waibel@gmx.net
**/





#define __DISPLAY_H

#ifndef __TYPE_SIZES_H
        #include <type_sizes.h>
#endif



#define NO_DISPLAY            0
#define LOCAL_DISPLAY         1
#define LOCAL_DISPLAY_PROCESS 2
#define REMOTE_DISPLAY        3





int  OpenVisual();      /* should open a window/screen     */
int  CloseVisual();     /* should close that window/screen */

void RefreshVisual();   /* should redraw the window/screen
                           (this is called whenever
                           a redraw is needed)             */


void GetVisualName(char *, int *n);    /* guess! :)        */
void SetVisualTitle(char *);           /* guess! :)        */


/* for RDP */

void SetVisualClipRect(int x, int y, int width, int height);
void DrawVisualFillRect(int ulx, int uly, int lrx, int lry, int color);




